import TodosStore from './todos-store';
import { state, action, selector } from 'redio';

export default class FilterTodosStore extends TodosStore {
    @state filter = 'SHOW_ALL';

    @selector(state => state.todos, state => state.filter)
    visibleTodos(todos, filter) {
        switch (filter) {
            case 'SHOW_ALL':
                return todos
            case 'SHOW_COMPLETED':
                return todos.filter(t => t.completed)
            case 'SHOW_ACTIVE':
                return todos.filter(t => !t.completed)
            default:
                throw new Error('Unknown filter: ' + filter)
        }
    }

    @action setFilter(filter) {
        this.filter = filter;
    }
}
