import { PureComponent } from 'react';

export default class StoreComponent extends PureComponent {
    constructor(props, Store) {
        super(props);
        const store = Store.init({ props });
        this.state = store.state;
        this.unsubscribe = store.register((state) => {
            this.setState(state);
        });
        this.store = store;
        Object.keys(this.store.actions).forEach((key) => {
            this.store[key] = this.store.actions[key];
        });

        Object.keys(this.store._effects).forEach((key) => {
            this.store[key] = this.store._effects[key];
        });
    }

    componentWillMount() {
        if (this.store.willMount) this.store.willMount();
    }

    componentDidMount() {
        if (this.store.didMount) this.store.didMount();
    }

    componentWillReceiveProps(nextProps) {
        this.store.setProps(nextProps);
    }

    componentWillUnmount() {
        if (this.store.willUnmount) this.store.willUnmount();
        this.unsubscribe();
        this.store = null;
    }
}
