/*
 * @Author: lijianzhang
 * @Date: 2017-10-07 01:35:49
 * @Last Modified by: lijianzhang
 * @Last Modified time: 2017-10-08 03:58:47
 * @flow
 */
import BaseStore from '../base';

export default function action(store: BaseStore, key: string, descriptor: Object) {
    if (!descriptor.hideAction && !Object.prototype.hasOwnProperty.call(store.constructor, 'actionKeys')) {
        const actionKeys = Object.getPrototypeOf(store).constructor.actionKeys;
        store.constructor.actionKeys = actionKeys ? [...actionKeys] : [];
    }

    if (!descriptor.hideAction) store.constructor.actionKeys.push(key);

    const value = descriptor.value;
    descriptor.enumerable = true;
    descriptor.value = function action(payload: any) {
        this.$beginChangeState = true;
        let state = null;
        try {
            if (process.env.NODE_ENV === 'development') {
                /* eslint-disable no-console */
                console.log(2);
                console.group(`%c action%c  (${this.name}/${key})`, 'color: #001B44', 'color: #001B44');
                console.log('%c old state', 'color: #9E9E9E', this.state);
                console.log('%c payload: ', 'color: #03A9F4', payload);
                state = value.call(this, payload, this.state);
                if (this._tempState) {
                    console.log('%c edit state: ', 'color: #03A9F4', this._tempState);
                }
                console.log('%c new state', 'color: #4CAF50', this.state);
            } else {
                state = value.call(this, payload, this.state);
            }
        } catch (error) {
            console.log('%c error', 'color: #ff4a4e', error.message);
            this.constructor.onError(error);
        } finally {
            if (process.env.NODE_ENV === 'development') {
                console.groupEnd();
            }
        }
        /* eslint-enable */

        this.$beginChangeState = false;

        if (state) {
            this._state = state;
        } else {
            this._updateState();
        }
        this.subscribers.forEach(fn => fn(this.state));
        return state;
    };
    return descriptor;
}
