export default function effect(store, key, descriptor) {
    if (!Object.prototype.hasOwnProperty.call(store.constructor, 'effectKeys')) {
        const effectKeys = Object.getPrototypeOf(store).constructor.effectKeys;
        store.constructor.effectKeys = effectKeys ? [...effectKeys] : [];
    }
    store.constructor.effectKeys.push(key);

    const value = descriptor.value;
    descriptor.value = async function asyncAction(data) {
        const res = value.call(this, data);
        if (res && res.then) {
            try {
                this.pendingStatus({ key, data });
                await res;
                this.fulfilledStatus({ key });
            } catch (error) {
                this.constructor.onError(error);
                this.rejectedStatus({ key, error });
            }
        } else {
            try {
                await res;
            } catch (error) {
                this.constructor.onError(error);
            }
        }
    };

    return descriptor;
}
