import { createSelector } from 'reselect';

export default function selector(...fns) {
    return (store, key, descriptor) => {
        if (!Object.prototype.hasOwnProperty.call(store.constructor, 'selectorKeys')) {
            const selectorKeys = Object.getPrototypeOf(store).constructor.selectorKeys;
            store.constructor.selectorKeys = selectorKeys ? [...selectorKeys] : [];
        }

        store.constructor.selectorKeys.push(key);
        fns.forEach((fn, index) => {
            if (typeof fn === 'string') {
                fns[index] = store[fn];
            }
        });
        const selector = createSelector(...fns, descriptor.value);
        descriptor.value = selector;
        return descriptor;
    };
}
