import BaseStore from './base';
import state from './decorators/state';
import action from './decorators/action';
import hideAction from './decorators/hide-action';

export default class Store extends BaseStore {
    @state
    effects = {};

    @action
    @hideAction(true)
    pendingStatus({ key, data }) {
        this.effects = { ...this.effects, [key]: { pending: true, error: false, data } };
    }

    @action
    @hideAction(true)
    fulfilledStatus({ key }) {
        this.effects = {
            ...this.effects,
            [key]: { pending: false, error: false },
        };
    }

    @action
    @hideAction(true)
    rejectedStatus({ key, error }) {
        this.effects = {
            ...this.effects,
            [key]: { pending: false, error },
        };
    }
}
