import { state, action, Store, effect } from '../src';

describe('effect', () => {
    class OrderStore extends Store {
        @state price = 3
        @state amount = 2
        @state orders = []

        @action addOrder(order) {
            this.orders = [...this.orders, order];
        }

        @effect async asyncAddOrder(data) {
            this.addOrder(data);
        }
    }
    test('async use action', async () => {
        const orderStore = new OrderStore();
        await orderStore.asyncAddOrder({ order: 2 });
        expect(orderStore.orders).toEqual([{ order: 2 }]);
    });
});
