import { state, action, Store, selector } from '../src';

describe('effect', () => {
    class OrderStore extends Store {
        @state price = 3
        @state amount = 2
        @state orders = []

        @selector(state => state.price)
        profit(price) {
            return price + 2;
        }

        @action setPrice(price) {
            this.price = price;
        }
    }
    test('init profit', async () => {
        const orderStore = new OrderStore();
        expect(orderStore.profit).toBe(5);
    });
    test('change profit', async () => {
        const orderStore = new OrderStore();
        orderStore.setPrice(10);
        expect(orderStore.profit).toBe(12);
    });
});
